import { NamedNode, Node, SignaturedDeclaration, SourceFile } from 'ts-simple-ast';
import * as ts from 'typescript';
import { CodeFixOptions } from 'typescript-plugin-util';
import { Action } from "typescript-plugins-text-based-user-interaction";
import * as ts_module from 'typescript/lib/tsserverlibrary';
import { SignatureRefactorArgs, SignatureRefactorsCodeFix } from '../../refactors';
/**
 * # TODO
 *  * refactor a nimplementation method wont change its interface signature - super
 *  * constructors not supported
 */
export declare class ReorderParamsCodeFixImpl implements SignatureRefactorsCodeFix {
    private options;
    private interactionTool;
    name: string;
    config: any;
    selectedAction?: Action;
    constructor(options: SignatureRefactorArgs);
    description(arg: CodeFixOptions): string;
    apply(arg: CodeFixOptions): void | ts.ApplicableRefactorInfo[];
    predicate(arg: CodeFixOptions): boolean;
    getCompletionsAtPosition(fileName: string, position: number, options: ts.GetCompletionsAtPositionOptions): ts.CompletionEntry[];
    getApplicableRefactors(info: ts_module.server.PluginCreateInfo, refactorName: string, refactorActionName: string, fileName: string, positionOrRange: number | ts.TextRange, userPreferences: ts_module.UserPreferences): {
        refactors: ts.ApplicableRefactorInfo[];
        selectedAction?: Action;
    };
    private getTextUITool;
    private getTargetNode;
    private getTextUIToolConfig;
}
export declare function getSimpleTargetNode(file: SourceFile, position: number, name: string, log: (msg: string) => void): SignaturedDeclaration & NamedNode & Node | undefined;
